use strict;
use europa_all;
use component_utils;

my $options = component_utils::get_args(@ARGV);

# Extract the component (perl package) to build.
my $component = $options->{component};
delete $options->{component};
my $factory = $options->{factory};
delete $options->{factory};

require "$component/$factory.pm";

# Extract the target directory from the options.
my $target_dir = $options->{target_dir};
delete $options->{target_dir};
$target_dir = '.' if !defined $target_dir;

my $top_module_factory = $component;
if ($component ne $factory)
{
  $top_module_factory = "$component\::$factory";
}
my $top_module = $top_module_factory->new($options)->module();

my $project = e_project->new({
  do_write_ptf => 0,
  _system_directory => $target_dir,
});

$project->top($top_module);
$project->output();


