package spi_slave;
use europa_module_factory;
@ISA = qw(europa_module_factory);
use spi_slave::rx;
use spi_slave::fifo;
use strict;

sub add_contents_to_module
{
  my $this = shift;
  my $module = $this->module();

  my $rx = spi_slave::rx->new({
    lsbfirst => $this->lsbfirst(),
    datawidth => $this->datawidth(),
  });
  $module->add_contents(
    $rx->make_instance({
      name => "the_rx",
    }),
  );

  my $fifo = spi_slave::fifo->new({
    datawidth => $this->datawidth(),
  });
  $module->add_contents(
    $fifo->make_instance({
      name => "rx_fifo",
      port_map => {
         read => "rx_fifo_read",
         readdata => "rx_fifo_readdata",
         write => "rx_fifo_write",
         writedata => "rx_fifo_writedata",
         empty => "rx_fifo_empty",
         full => "rx_fifo_full",
      },
    }),
  );
}

sub get_fields
{
  my $class = shift;

  my %fields = (
    datawidth => 
    {
      range => [1, undef],
    },
    lsbfirst => 
    {
      range => [0, 1],
    },
  );

  return \%fields;
}

1;

